<script lang="ts">
import {
  and,
  type ControlElement,
  formatIs,
  isStringControl,
  type JsonFormsRendererRegistryEntry,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import { defineComponent, ref } from "vue";
import { VHover } from "vuetify/components";

const controlRenderer = defineComponent({
  name: "OrcidControlRenderer",
  components: { ControlWrapper, VHover },
  directives: { DisabledIconFocus },
  props: { ...rendererProps<ControlElement>() },
  setup(props: RendererProps<ControlElement>) {
    const control = useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );

    const search = ref(control.control.value?.data || "");
    const loading = ref(false);

    const onInput = async (val: string) => {
      const inputValue = val?.data || search.value;

      // If ORCID is empty, clear firstname, lastname, and ORCID fields
      if (!inputValue) {
        const match = control.control.value.path.match(/^(\d+)\./);
        const pos = match ? Number.parseInt(match[1], 10) : null;

        const pathFirstname = pos !== null ? `${pos}.person.firstname` : "firstname";
        const pathLastname = pos !== null ? `${pos}.person.lastname` : "lastname";
        const pathOrcid = pos !== null ? `${pos}.person.orcid` : "orcid";

        control.handleChange(pathFirstname, "");
        control.handleChange(pathLastname, "");
        control.handleChange(pathOrcid, "");
        search.value = "";
        return;
      }

      // Validate the ORCID format
      if (!/^\d{4}-\d{4}-\d{4}-\d{4}$/.test(inputValue)) {
        return;
      }

      loading.value = true;
      try {
        const url = `https://pub.orcid.org/v3.0/${inputValue}`;
        const response = await fetch(url, { headers: { Accept: "application/json" } });

        if (!response.ok) throw new Error(`Error: ${response.statusText}`);

        const data = await response.json();
        const name = data.person?.name;
        if (name) {
          const firstname = name["given-names"]?.value || "Firstname not given";
          const lastname = name["family-name"]?.value || "Lastname not given";

          // Derive paths dynamically based on the control path
          const match = control.control.value.path.match(/^(\d+)\./);
          const pos = match ? Number.parseInt(match[1], 10) : null;

          const pathFirstname = pos !== null ? `${pos}.person.firstname` : "firstname";
          const pathLastname = pos !== null ? `${pos}.person.lastname` : "lastname";
          const pathOrcid = pos !== null ? `${pos}.person.orcid` : "orcid";

          // Update the schema with ORCID data
          control.handleChange(pathFirstname, firstname);
          control.handleChange(pathLastname, lastname);
          control.handleChange(pathOrcid, inputValue);

          // Update the search field to reflect the person's name
          search.value = `${inputValue}`;
        }
      } catch (error) {
        console.error("ORCID API Error:", error.message);
      } finally {
        loading.value = false;
      }
    };

    return { ...control, search, loading, onInput };
  },
});

export default controlRenderer;

export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(100, and(isStringControl, formatIs("orcid"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :isFocused="isFocused"
    :appliedOptions="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <v-text-field
        :id="`${control.id}-input`"
        v-model="search"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        :required="control.required"
        :error-messages="control.errors"
        :clearable="isHovering"
        :loading="loading"
        @input="onInput"
        @focus="handleFocus"
        @blur="handleBlur"
      />
    </VHover>
  </ControlWrapper>
</template>
